//+------------------------------------------------------------------+
//|                                                NewsGenerator.mq4 |
//+------------------------------------------------------------------+

// Created by mqldev - www.mqldev.com
// ffc2csv created by The_N
// Shell script created by codersguru

// This code is free but with a hope you refer your friends to www.mqldev.com

/*
         ffc2csv is ForexFactory.com calendar to CSV converter.

         ffc2csv v1.0 Usage:
         ffc2csv.exe             Convert current calendar
         -t   12 or 24           Output time format, am/pm or 24 hour
         -y   2000-2006          Calendar year
         -m   1-12               Calendar month
         -z                      Time zone (for more information use -hz flag)
         -s   , or .             Decimal separator
         -f   HIGHMEDLOWALL      Volatile filter
         -o                      output file (default: ff.csv)
         -d                      delete downloaded html file
         -hz                     Time zone help
         -h                      Help screen

         Example:
         ffc2csv.exe -t 24 -y 2006 -m 12 -z g2 -c , -f HIGHMED -o myff.csv -d

         ffc2csv.exe -t 12 -z t-9 -f ALL
*/

#property show_inputs

extern   string      ffc2csvPath       = "c:\ffc2csv.exe";
extern   string      TimeFormat        = "24";
extern   string      GetYear           = "2006";
extern   string      GetMonth          = "";
extern   string      TimeZone          = "g1";
extern   string      DecimalSeparator  = ".";
extern   string      VolatileFilter    = "ALL";
extern   string      OutputFile        = "News2.csv";
extern   bool        DeleteHtmlFile    = true;


//+------------------------------------------------------------------+
//| dlls imports (you have to enable "Allow DLL imports"             
//+------------------------------------------------------------------+

#import "shell32.dll"
   int ShellExecuteA(int hwnd,string lpOperation, string lpFile,string lpParameters,string lpDirectory,int nShowCmd );
#import

int start()
{
   
   if(!Shell(ffc2csvPath,BuildParms()))
      Alert ("There's something wrong!");
   return(0);
}


//+------------------------------------------------------------------+
//| String Functions                                                 
//+------------------------------------------------------------------+
int StringFindReverse( string text, string matched_text, int start=0) 
{
   string temp1 = StringReverse(text);
   string temp2 = StringReverse(matched_text);
   int pos = StringFind(temp1,temp2,start);
   return(pos);
}

string StringReverse (string text)
{
   string temp;
   for(int i = 0 ; i <= StringLen(text) ; i++) 
   {
     temp = temp + StringSubstr(text,StringLen(text)-i,1);  
   }
   return (temp);
}

string GetFileName (string path)
{
   int pos = StringFindReverse(path,"\\",0);
   if (pos > -1)
      return (StringSubstr(path,StringLen(path)-pos,pos));
   else
      return ("");
}

string GetDirName (string path)
{
   int pos = StringFindReverse(path,"\\",0);
   if (pos > -1)
      return (StringSubstr(path,0,StringLen(path)-pos));
   else
      return ("");
}

//+------------------------------------------------------------------+
//| Shell Function                                                   
//| Usage: 
//|   use this function to run any program you want from your MQL code 
//| Parameters:
//|   FullPath (string) the full path and thr file name
//|   Parameters (string) any parameters you wanna pass to the program   
//| Return vale: 
//|   (int) the handle of the program in success and -1 in error
//| Example:   
//|   int res = Shell ("c:\\window\\notepad.exe", "");
//+------------------------------------------------------------------+

int Shell( string FullPath , string Parameters = "")
{
   string file = GetFileName(FullPath); //get file name from the path
   string dir = GetDirName(FullPath); //get the directory name from the path
   if (file != "" && dir != "") 
      return (ShellExecuteA(0,"Open" ,file,Parameters,dir,1)); //call ShellExecute
   else
      return (-1); //error
}

//+------------------------------------------------------------------+

string BuildParms ()
{
   string parm = " ";
   
   if (TimeFormat != "")
      parm = "-t " + TimeFormat;
   if (GetYear != "")
      parm = parm + " -y " + GetYear;
   if (GetMonth != "")
      parm = parm + " -m " + GetMonth;
   if (TimeZone != "")
      parm = parm + " -z " + TimeZone;
   if (DecimalSeparator != "")
      parm = parm + " -s " + DecimalSeparator;
   if (VolatileFilter != "")
      parm = parm + " -f " + VolatileFilter;
   if (OutputFile != "")
      parm = parm + " -o " + OutputFile;
   if (DeleteHtmlFile)
      parm = parm + " -d ";
      
   return(parm);
}